TD_TTLV_TYPE_SYMBOL             = 0x1
TD_TTLV_TYPE_BYTESTRING         = 0x2
TD_TTLV_TYPE_UNICODESTRING      = 0x3
TD_TTLV_TYPE_INTEGER            = 0x4
TD_TTLV_TYPE_SHORTINTEGER       = 0x5
TD_TTLV_TYPE_PAIR               = 0x6
TD_TTLV_TYPE_UUID               = 0x7

TD_TTLV_TAG_LTDID               = 0x01
TD_TTLV_TAG_LTDROLE             = 0x02
TD_TTLV_TAG_CN                  = 0x03
TD_TTLV_TAG_OBJECTID            = 0x10
TD_TTLV_TAG_SESSIONID           = 0x11
TD_TTLV_TAG_CONTAINERID         = 0x12
TD_TTLV_TAG_CONTAINERNAME       = 0x20
TD_TTLV_TAG_CONTAINERTYPE       = 0x21
TD_TTLV_TAG_SIGNEDDATA          = 0x30
TD_TTLV_TAG_DBKEYVALUE          = 0x40
TD_TTLV_TAG_DBKEY               = 0x41
TD_TTLV_TAG_DBVALUE             = 0x42
TD_TTLV_TAG_STATUSCODE          = 0x50
TD_TTLV_TAG_PERMANENTFILE       = 0x60
TD_TTLV_TAG_PERMANENTDATABASE   = 0x61
TD_TTLV_TAG_FILE                = 0x62
TD_TTLV_TAG_DATABASE            = 0x63
TD_TTLV_TAG_EVENT               = 0x70
TD_TTLV_TAG_SUBJECT             = 0x80
TD_TTLV_TAG_CONTEXT             = 0x81
TD_TTLV_TAG_SIZEINBYTES         = 0x90
TD_TTLV_TAG_DATA                = 0x91
TD_TTLV_TAG_NONCE               = 0x92
TD_TTLV_TAG_KEYTYPE             = 0xA0
TD_TTLV_TAG_RSAKEY1024          = 0xA1
TD_TTLV_TAG_RSAKEY2048          = 0xA2
TD_TTLV_TAG_RSAKEY4096          = 0xA3
TD_TTLV_TAG_SYMMETRICKEY128     = 0xA4
TD_TTLV_TAG_SYMMETRICKEY256     = 0xA5

TD_OPENCONNECTION_CMD           = 0x01
TD_OPENCONNECTION_RSP           = 0x02
TD_CLOSECONNECTION_CMD          = 0x03
TD_CLOSECONNECTION_RSP          = 0x04
TD_CREATESESSION_CMD            = 0x10
TD_CREATESESSION_RSP            = 0x11
TD_CLOSESESSION_CMD             = 0x12
TD_CLOSESESSION_RSP             = 0x13
TD_CREATEOBJECT_CMD             = 0x20
TD_CREATEOBJECT_RSP             = 0x21
TD_PUTOBJECTVALUE_CMD           = 0x22
TD_PUTOBJECTVALUE_RSP           = 0x23
TD_GETOBJECTVALUE_CMD           = 0x24
TD_GETOBJECTVALUE_RSP           = 0x25
TD_CREATEARCHIVE_CMD            = 0x30
TD_CREATEARCHIVE_RSP            = 0x31
TD_ARCHIVE_CMD                  = 0x32
TD_ARCHIVE_RSP                  = 0x33
TD_CLOSEARCHIVE_CMD             = 0x34
TD_CLOSEARCHIVE_RSP             = 0x35
TD_CREATESTORAGE_CMD            = 0x40
TD_CREATESTORAGE_RSP            = 0x41
TD_DELETESTORAGE_CMD            = 0x42
TD_DELETESTORAGE_RSP            = 0x43
TD_STOREDATA_CMD                = 0x44
TD_STOREDATA_RSP                = 0x45
TD_GETSTORAGEVALUE_CMD          = 0x46
TD_GETSTORAGEVALUE_RSP          = 0x47
TD_GETSTORAGE_CMD               = 0x48
TD_GETSTORAGE_RSP               = 0x49
TD_SEARCH_CMD                   = 0x4A
TD_SEARCH_RSP                   = 0x4B
TD_GETRANDOM_CMD                = 0x50
TD_GETRANDOM_RSP                = 0x51
TD_GENERATEENCRYPTIONKEY_CMD    = 0x52
TD_GENERATEENCRYPTIONKEY_RSP    = 0x53
TD_GETTRUSTEDTIMESTAMP_CMD      = 0x54
TD_GETTRUSTEDTIMESTAMP_RSP      = 0x55
TD_TRUSTRENEWAL_CMD             = 0x56
TD_TRUSTRENEWAL_RSP             = 0x57
TD_GETVALUE_CMD                 = 0x60
TD_GETVALUE_RSP                 = 0x61
TD_DUMPCONNECTION_CMD           = 0xA0
TD_DUMPCONNECTION_RSP           = 0xA1
APP_KILLSWITCH_CMD              = 0xB0
APP_KILLSWITCH_RSP              = 0xB1

TDSC_SUCCESS                        = 0x00
TDSC_GENERAL_FAILURE                = 0x01
TDSC_SESSION_ID_ALREADY_OPENED      = 0x02
TDSC_TOO_MANY_EXISTING_SESSIONS     = 0x03
TDSC_ON_GOING_PROCESSES             = 0x04
TDSC_TOO_MANY_OPENED_CONNECTIONS    = 0x05
TDSC_TRUST_REFUSED                  = 0x10
TDSC_TRUST_EXPIRED                  = 0x11
TDSC_UNKNOWN_ROLE                   = 0x20
TDSC_UNKNOWN_SESSION_ID             = 0x30
TDSC_UNKNOWN_OBJECT_ID              = 0x31
TDSC_UNKNOWN_CONTAINER_ID           = 0x32
TDSC_UNKNOWN_KEY_ID                 = 0x33
TDSC_UNKNOWN_ARCHIVE_ID             = 0x34
TDSC_OBJECT_CREATION_FAILED         = 0x40
TDSC_ARCHIVE_CREATION_FAILED        = 0x41
TDSC_CONTAINER_CREATION_FAILED      = 0x42
TDSC_CONTAINER_TYPE_NOT_SUPPORTED   = 0x50
TDSC_CONTAINER_WRITE_ONLY           = 0x51
TDSC_CONTAINER_NAME_ALREADY_EXISTS  = 0x52
TDSC_CONTAINER_NAME_NOT_FOUND       = 0x53
TDSC_DATA_TYPE_NOT_SUPPORTED        = 0x54
TDSC_STORAGE_FULL                   = 0x55
TDSC_STORAGE_BUSY                   = 0x56
TDSC_UNKNWON_KEY                    = 0x60
TDSC_UNKNOWN_KEY_TYPE               = 0x61
TDSC_KEY_SIZE_NOT_SUPPORTED         = 0x62
TDSC_VALUE_NOT_FOUND                = 0x70
TDSC_NOT_ENOUGH_ENTROPY             = 0x71
TDSC_ATTESTATION_FAILED             = 0x72

TDSC_CONTAINER_TYPE_FILE            = 0x01
TDSC_CONTAINER_TYPE_DATABASE        = 0x02
TDSC_CONTAINER_TYPE_PERM_FILE       = 0x03
TDSC_CONTAINER_TYPE_PERM_DATABASE   = 0x04